from decimal import Decimal
from typing import Self

class Currency:
    def __new__(cls, amount: str | float | Decimal, alpha_code: str | None = ..., numeric_code: str | None = ..., symbol: str | None = ..., localized_symbol: str | None = ..., convertion: str | None = ..., pattern: str | None = ...) -> Self: ...
    def __abs__(self) -> Self: ...
    def __add__(self, other: object) -> Self: ...
    def __bool__(self) -> bool: ...
    def __ceil__(self) -> Self: ...
    def __copy__(self) -> Self: ...
    def __divmod__(self, other: float | Decimal) -> tuple[Self, Self]: ...
    def __eq__(self, other: object) -> bool: ...
    def __float__(self) -> float: ...
    def __floor__(self) -> Self: ...
    def __floordiv__(self, other: float | Decimal) -> Self: ...
    def __format__(self, fmt: str = ...) -> str: ...
    def __ge__(self, other: object) -> bool: ...
    def __gt__(self, other: object) -> bool: ...
    def __hash__(self) -> int: ...
    def __int__(self) -> int: ...
    def __le__(self, other: object) -> bool: ...
    def __lt__(self, other: object) -> bool: ...
    def __mod__(self, other: float | Decimal) -> Self: ...
    def __mul__(self, other: float | Decimal) -> Self: ...
    def __ne__(self, other: object) -> bool: ...
    def __neg__(self) -> Self: ...
    def __pos__(self) -> Self: ...
    def __recreate__(self, amount: str | float | Decimal) -> Self: ...
    def __reduce__(self) -> tuple[type, tuple[object, ...]]: ...
    def __round__(self, precision: int | None = ...) -> Self: ...
    def __rsub__(self, other: object) -> Self: ...
    def __sub__(self, other: object) -> Self: ...
    def __truediv__(self, other: float | Decimal) -> Self: ...
    __deepcopy__: Self
    __rmul__: Self
    def international(self, precision: int | None = ...) -> str: ...
    def is_signed(self) -> bool: ...
    def localized(self, precision: int | None = ...) -> str: ...
    def precision(self, precision: int | None = ...) -> str: ...
    @property
    def amount(self) -> Decimal: ...
    @property
    def alpha_code(self) -> str: ...
    @property
    def numeric_code(self) -> str: ...
    @property
    def symbol(self) -> str: ...
    @property
    def localized_symbol(self) -> str: ...
    @property
    def convertion(self) -> str: ...
    @property
    def pattern(self) -> str: ...
